#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.CheckBox checkBox2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox2;
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
    private bool SetEmpty = true;
    private Button button1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
InitializeControlSettings();


			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
      this.panel1 = new System.Windows.Forms.Panel();
      this.groupBox2 = new System.Windows.Forms.GroupBox();
      this.label2 = new System.Windows.Forms.Label();
      this.textBox2 = new System.Windows.Forms.TextBox();
      this.checkBox2 = new System.Windows.Forms.CheckBox();
      this.groupBox1 = new System.Windows.Forms.GroupBox();
      this.button1 = new System.Windows.Forms.Button();
      this.label1 = new System.Windows.Forms.Label();
      this.textBox1 = new System.Windows.Forms.TextBox();
      this.checkBox1 = new System.Windows.Forms.CheckBox();
      this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
      this.panel1.SuspendLayout();
      this.groupBox2.SuspendLayout();
      this.groupBox1.SuspendLayout();
      this.SuspendLayout();
      // 
      // panel1
      // 
      this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.panel1.BackColor = System.Drawing.Color.White;
      this.panel1.Controls.Add(this.groupBox2);
      this.panel1.Controls.Add(this.groupBox1);
      this.panel1.Location = new System.Drawing.Point(392, 0);
      this.panel1.Name = "panel1";
      this.panel1.Size = new System.Drawing.Size(160, 376);
      this.panel1.TabIndex = 0;
      // 
      // groupBox2
      // 
      this.groupBox2.Controls.Add(this.label2);
      this.groupBox2.Controls.Add(this.textBox2);
      this.groupBox2.Controls.Add(this.checkBox2);
      this.groupBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.groupBox2.Location = new System.Drawing.Point(8, 192);
      this.groupBox2.Name = "groupBox2";
      this.groupBox2.Size = new System.Drawing.Size(144, 168);
      this.groupBox2.TabIndex = 1;
      this.groupBox2.TabStop = false;
      this.groupBox2.Text = "Series 2";
      // 
      // label2
      // 
      this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.label2.Location = new System.Drawing.Point(12, 62);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(64, 16);
      this.label2.TabIndex = 4;
      this.label2.Text = "Text";
      // 
      // textBox2
      // 
      this.textBox2.Location = new System.Drawing.Point(12, 86);
      this.textBox2.Name = "textBox2";
      this.textBox2.Size = new System.Drawing.Size(120, 20);
      this.textBox2.TabIndex = 3;
      this.textBox2.Text = "textBox2";
      this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
      // 
      // checkBox2
      // 
      this.checkBox2.Checked = true;
      this.checkBox2.CheckState = System.Windows.Forms.CheckState.Checked;
      this.checkBox2.Cursor = System.Windows.Forms.Cursors.Hand;
      this.checkBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.checkBox2.Location = new System.Drawing.Point(16, 32);
      this.checkBox2.Name = "checkBox2";
      this.checkBox2.Size = new System.Drawing.Size(112, 16);
      this.checkBox2.TabIndex = 1;
      this.checkBox2.Text = "Visible";
      this.checkBox2.CheckedChanged += new System.EventHandler(this.checkBox2_CheckedChanged);
      // 
      // groupBox1
      // 
      this.groupBox1.Controls.Add(this.button1);
      this.groupBox1.Controls.Add(this.label1);
      this.groupBox1.Controls.Add(this.textBox1);
      this.groupBox1.Controls.Add(this.checkBox1);
      this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.groupBox1.Location = new System.Drawing.Point(8, 16);
      this.groupBox1.Name = "groupBox1";
      this.groupBox1.Size = new System.Drawing.Size(144, 168);
      this.groupBox1.TabIndex = 0;
      this.groupBox1.TabStop = false;
      this.groupBox1.Text = "Series 1";
      // 
      // button1
      // 
      this.button1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.button1.ForeColor = System.Drawing.Color.Red;
      this.button1.Location = new System.Drawing.Point(19, 126);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(99, 23);
      this.button1.TabIndex = 3;
      this.button1.Text = "Add Series";
      this.button1.UseVisualStyleBackColor = true;
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // label1
      // 
      this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.label1.Location = new System.Drawing.Point(16, 56);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(64, 16);
      this.label1.TabIndex = 2;
      this.label1.Text = "Text";
      // 
      // textBox1
      // 
      this.textBox1.Location = new System.Drawing.Point(16, 80);
      this.textBox1.Name = "textBox1";
      this.textBox1.Size = new System.Drawing.Size(120, 20);
      this.textBox1.TabIndex = 1;
      this.textBox1.Text = "textBox1";
      this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
      // 
      // checkBox1
      // 
      this.checkBox1.Checked = true;
      this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
      this.checkBox1.Cursor = System.Windows.Forms.Cursors.Hand;
      this.checkBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.checkBox1.Location = new System.Drawing.Point(16, 24);
      this.checkBox1.Name = "checkBox1";
      this.checkBox1.Size = new System.Drawing.Size(112, 16);
      this.checkBox1.TabIndex = 0;
      this.checkBox1.Text = "Visible";
      this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
      // 
      // chartControl1
      // 
      this.chartControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                  | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      // 
      // 
      // 
      this.chartControl1.ChartArea.ChartAreaMargins.Bottom = 10;
      this.chartControl1.ChartArea.ChartAreaMargins.Left = 10;
      this.chartControl1.ChartArea.ChartAreaMargins.Right = 20;
      this.chartControl1.ChartArea.ChartAreaMargins.Top = 10;
      this.chartControl1.ChartArea.ChartPlotAreaMargins.Bottom = 10;
      this.chartControl1.ChartArea.ChartPlotAreaMargins.Left = 10;
      this.chartControl1.ChartArea.ChartPlotAreaMargins.Right = 20;
      this.chartControl1.ChartArea.ChartPlotAreaMargins.Top = 10;
      this.chartControl1.ChartArea.HidePartialLabels = true;
      this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb(((int)(((byte)(55)))), ((int)(((byte)(245)))), ((int)(((byte)(245)))), ((int)(((byte)(220))))), System.Drawing.Color.White);
      this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.chartControl1.HidePartialLabels = true;
      // 
      // 
      // 
      this.chartControl1.Legend.BackColor = System.Drawing.SystemColors.Control;
      this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
      this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
      this.chartControl1.Legend.Location = new System.Drawing.Point(152, 39);
      this.chartControl1.Legend.Name = "";
      this.chartControl1.Legend.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
      this.chartControl1.Legend.TabIndex = 3;
      this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartDock.Top;
      this.chartControl1.Location = new System.Drawing.Point(0, 0);
      this.chartControl1.Name = "chartControl1";
      this.chartControl1.Palette = Syncfusion.Windows.Forms.Chart.ChartColorPalette.Default;
      this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
      this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
      this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
      this.chartControl1.Size = new System.Drawing.Size(392, 376);
      this.chartControl1.TabIndex = 2;
      this.chartControl1.Text = "Essential Chart";
      this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
      this.chartControl1.Paint += new System.Windows.Forms.PaintEventHandler(this.chartControl1_Paint);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(552, 374);
      this.Controls.Add(this.panel1);
      this.Controls.Add(this.chartControl1);
      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
      this.Name = "Form1";
      this.Text = "Essential Chart - ChartSeriesSample";
      this.Load += new System.EventHandler(this.Form1_Load);
      this.panel1.ResumeLayout(false);
      this.groupBox2.ResumeLayout(false);
      this.groupBox2.PerformLayout();
      this.groupBox1.ResumeLayout(false);
      this.groupBox1.PerformLayout();
      this.ResumeLayout(false);

		}
		#endregion

		private void InitializeControlSettings()
	  {
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

		  // Specify a ChartPalette:
		  Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
		  this.chartControl1.Palette = ChartColorPalette.Custom ;
		  this.chartControl1.Model.ColorModel.CustomColors = color;
		  this.chartControl1.Palette = ChartColorPalette.Custom ;

		  this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
		  this.chartControl1.LegendPosition = ChartDock.Top;
		this.chartControl1.HidePartialLabels = true;
	  }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void InitializeChartData()
		{
      this.checkBox1.Enabled = true;
      this.checkBox2.Enabled = true;
      this.textBox1.Enabled = true;
      this.textBox2.Enabled = true;

            try
            {
                ChartSeries series1 = this.chartControl1.Model.NewSeries("Series 1");
                series1.Points.Add(0, 500);
                series1.Points.Add(2, 340);
                series1.Points.Add(2, 340);
                series1.Points.Add(2, 340);

                series1.Style.Font.Bold = true;

                series1.Type = ChartSeriesType.StackingColumn;
                series1.Text = series1.Name;
                this.chartControl1.Series.Add(series1);

                ChartSeries series2 = this.chartControl1.Model.NewSeries("Series 2");
                series2.Points.Add(0, 500);
                series2.Points.Add(2, 340);
                series2.Points.Add(2, 340);
                series2.Points.Add(2, 340);

                series2.Style.Font.Bold = true;

                series2.Type = ChartSeriesType.Line;
                series2.Style.Border.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
                series2.Text = series2.Name;
                this.chartControl1.Series.Add(series2);

                //this.chartControl1.ColumnWidthMode = ChartColumnWidthMode.FixedWidthMode;
                //this.chartControl1.PrimaryYAxis.Range.Min = 0;

                // Preetam - Please chech for this line as it seems this part of code
                //           must be causing the problem. The debugger does not show the
                //           exact point of failure in this code.

                this.chartControl1.Series[0].Text = this.textBox1.Text;
                this.chartControl1.Series[1].Text = this.textBox2.Text;
                
                this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Auto;
                this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Auto;
                this.chartControl1.Text = "Essential Chart";
                this.chartControl1.Legend.Visible = true;
              }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
		}

    protected void ShowEmptyChart()
    {
      this.chartControl1.Text = "Empty Chart";
      this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
      this.chartControl1.PrimaryXAxis.Range = new MinMaxInfo(0, 0, 0);
      this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;
      this.chartControl1.PrimaryYAxis.Range = new MinMaxInfo(0, 0, 0);
    }

		private void Form1_Load(object sender, System.EventArgs e)
		{
      this.checkBox1.Enabled = false;
      this.checkBox2.Enabled = false;
      this.textBox1.Enabled = false;
      this.textBox2.Enabled = false;

      ShowEmptyChart();
      this.chartControl1.Legend.Visible = false;
			//InitializeChartData();
		}

    private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
    {
      this.chartControl1.Series[0].Visible = this.checkBox1.Checked;
      chartControl1.PrimaryYAxis.Range.Min = 0;
    }

    private void checkBox2_CheckedChanged(object sender, System.EventArgs e)
    {
      this.chartControl1.Series[1].Visible = this.checkBox2.Checked;
      chartControl1.PrimaryYAxis.Range.Min = 0;
      this.chartControl1.Refresh();
    }

    private void textBox1_TextChanged(object sender, System.EventArgs e)
    {
      this.chartControl1.Series[0].Text = this.textBox1.Text;
      this.chartControl1.Refresh();
    }

    private void textBox2_TextChanged(object sender, System.EventArgs e)
    {
      this.chartControl1.Series[1].Text = this.textBox2.Text;
      this.chartControl1.Refresh();
    }

    private void chartControl1_Paint(object sender, PaintEventArgs e)
    {
      if (SetEmpty)
      {
        this.chartControl1.Series.Clear();
      }
    }

    private void button1_Click(object sender, EventArgs e)
    {
      SetEmpty = false;
      InitializeChartData();
    }
	}
}
